diff --git a/gdb/tui/tui-data.c b/gdb/tui/tui-data.c
index 39381ea0859..89f65bf974f 100644
--- a/gdb/tui/tui-data.c
+++ b/gdb/tui/tui-data.c
@@ -420,8 +420,8 @@ tui_init_generic_part (struct tui_gen_win_info *win)
     win->last_visible_line = 0;
   win->handle = NULL;
   win->content = NULL;
-  win->content_in_use =
-    win->is_visible = FALSE;
+  win->content_in_use = FALSE;
+  win->is_visible = false;
   win->title = 0;
 }
 
diff --git a/gdb/tui/tui-data.h b/gdb/tui/tui-data.h
index 249f3cc81f4..34de67757b0 100644
--- a/gdb/tui/tui-data.h
+++ b/gdb/tui/tui-data.h
@@ -49,7 +49,7 @@ struct tui_gen_win_info
   int content_in_use;	    /* Can it be used, or is it already used?  */
   int viewport_height;	    /* Viewport height.  */
   int last_visible_line;    /* Index of last visible line.  */
-  int is_visible;	    /* Whether the window is visible or not.  */
+  bool is_visible;	    /* Whether the window is visible or not.  */
   char *title;              /* Window title to display.  */
 };
 
@@ -256,7 +256,7 @@ public:
   }
 
   /* Make this window visible or invisible.  */
-  virtual void make_visible (int visible);
+  virtual void make_visible (bool visible);
 
   /* Methods to scroll the contents of this window.  Note that they
      are named with "_scroll" coming at the end because the more
@@ -298,7 +298,7 @@ public:
     return m_has_locator;
   }
 
-  void make_visible (int visible) override;
+  void make_visible (bool visible) override;
 
   /* Does locator belongs to this window?  */
   bool m_has_locator = false;
@@ -393,7 +393,7 @@ struct tui_cmd_window : public tui_win_info
 
   void clear_detail () override;
 
-  void make_visible (int visible) override
+  void make_visible (bool visible) override
   {
   }
 
diff --git a/gdb/tui/tui-windata.c b/gdb/tui/tui-windata.c
index a0f20c309e1..67228a6c5ee 100644
--- a/gdb/tui/tui-windata.c
+++ b/gdb/tui/tui-windata.c
@@ -78,7 +78,7 @@ tui_delete_data_content_windows (void)
 	= &TUI_DATA_WIN->generic.content[i]->which_element.data_window;
       tui_delete_win (data_item_win_ptr->handle);
       data_item_win_ptr->handle = NULL;
-      data_item_win_ptr->is_visible = FALSE;
+      data_item_win_ptr->is_visible = false;
     }
 }
 
diff --git a/gdb/tui/tui-wingeneral.c b/gdb/tui/tui-wingeneral.c
index 1308437befd..e802e52ca5b 100644
--- a/gdb/tui/tui-wingeneral.c
+++ b/gdb/tui/tui-wingeneral.c
@@ -161,7 +161,7 @@ tui_make_window (struct tui_gen_win_info *win_info, int box_it)
     {
       if (box_it == BOX_WINDOW)
 	box_win (win_info, NO_HILITE);
-      win_info->is_visible = TRUE;
+      win_info->is_visible = true;
       scrollok (handle, TRUE);
     }
 }
@@ -171,7 +171,7 @@ tui_make_window (struct tui_gen_win_info *win_info, int box_it)
    delete the entire window when making it visible, and create it
    again when making it visible.  */
 static void
-make_visible (struct tui_gen_win_info *win_info, int visible)
+make_visible (struct tui_gen_win_info *win_info, bool visible)
 {
   /* Don't tear down/recreate command window.  */
   if (win_info->type == CMD_WIN)
@@ -184,14 +184,14 @@ make_visible (struct tui_gen_win_info *win_info, int visible)
 	  tui_make_window (win_info,
 			   (win_info->type != CMD_WIN
 			    && !tui_win_is_auxillary (win_info->type)));
-	  win_info->is_visible = TRUE;
+	  win_info->is_visible = true;
 	}
     }
   else if (!visible
 	   && win_info->is_visible
 	   && win_info->handle != NULL)
     {
-      win_info->is_visible = FALSE;
+      win_info->is_visible = false;
       tui_delete_win (win_info->handle);
       win_info->handle = NULL;
     }
@@ -202,19 +202,19 @@ make_visible (struct tui_gen_win_info *win_info, int visible)
 void
 tui_make_visible (struct tui_gen_win_info *win_info)
 {
-  make_visible (win_info, 1);
+  make_visible (win_info, true);
 }
 
 void
 tui_make_invisible (struct tui_gen_win_info *win_info)
 {
-  make_visible (win_info, 0);
+  make_visible (win_info, false);
 }
 
 /* See tui-data.h.  */
 
 void
-tui_win_info::make_visible (int visible)
+tui_win_info::make_visible (bool visible)
 {
   ::make_visible (&generic, visible);
 }
@@ -222,7 +222,7 @@ tui_win_info::make_visible (int visible)
 /* See tui-data.h.  */
 
 void
-tui_source_window_base::make_visible (int visible)
+tui_source_window_base::make_visible (bool visible)
 {
   ::make_visible (execution_info, visible);
   tui_win_info::make_visible (visible);
@@ -231,7 +231,7 @@ tui_source_window_base::make_visible (int visible)
 /* Makes all windows invisible (except the command and locator
    windows).  */
 static void
-make_all_visible (int visible)
+make_all_visible (bool visible)
 {
   int i;
 
@@ -247,13 +247,13 @@ make_all_visible (int visible)
 void
 tui_make_all_visible (void)
 {
-  make_all_visible (1);
+  make_all_visible (true);
 }
 
 void
 tui_make_all_invisible (void)
 {
-  make_all_visible (0);
+  make_all_visible (false);
 }
 
 /* Function to refresh all the windows currently displayed.  */
diff --git a/gdb/tui/tui.c b/gdb/tui/tui.c
index ce8de72f28d..d7201992ae4 100644
--- a/gdb/tui/tui.c
+++ b/gdb/tui/tui.c
@@ -655,14 +655,14 @@ tui_show_assembly (struct gdbarch *gdbarch, CORE_ADDR addr)
   tui_update_source_windows_with_addr (gdbarch, addr);
 }
 
-int
+bool
 tui_is_window_visible (enum tui_win_type type)
 {
   if (tui_active == 0)
-    return 0;
+    return false;
 
   if (tui_win_list[type] == 0)
-    return 0;
+    return false;
   
   return tui_win_list[type]->generic.is_visible;
 }
diff --git a/gdb/tui/tui.h b/gdb/tui/tui.h
index 5b8be0cd481..8f6ef64f496 100644
--- a/gdb/tui/tui.h
+++ b/gdb/tui/tui.h
@@ -56,7 +56,7 @@ enum tui_win_type
 extern CORE_ADDR tui_get_low_disassembly_address (struct gdbarch *,
 						  CORE_ADDR, CORE_ADDR);
 extern void tui_show_assembly (struct gdbarch *gdbarch, CORE_ADDR addr);
-extern int tui_is_window_visible (enum tui_win_type type);
+extern bool tui_is_window_visible (enum tui_win_type type);
 extern int tui_get_command_dimension (unsigned int *width,
 				      unsigned int *height);
 