diff --git a/gdb/tui/tui-data.c b/gdb/tui/tui-data.c
index af571450316..82af0c9cf77 100644
--- a/gdb/tui/tui-data.c
+++ b/gdb/tui/tui-data.c
@@ -36,8 +36,9 @@ struct tui_win_info *tui_win_list[MAX_MAJOR_WINDOWS];
 ****************************/
 static enum tui_layout_type current_layout = UNDEFINED_LAYOUT;
 static int term_height, term_width;
-static struct tui_gen_win_info _locator;
-static struct tui_gen_win_info exec_info[2];
+static struct tui_gen_win_info _locator (LOCATOR_WIN);
+static struct tui_gen_win_info source_win (EXEC_INFO_WIN);
+static struct tui_gen_win_info disasm_win (EXEC_INFO_WIN);
 static struct std::vector<tui_source_window_base *> source_windows;
 static struct tui_win_info *win_with_focus = NULL;
 static struct tui_layout_def layout_def = {
@@ -188,7 +189,7 @@ tui_data_window::clear_detail ()
 struct tui_gen_win_info *
 tui_source_exec_info_win_ptr (void)
 {
-  return &exec_info[0];
+  return &source_win;
 }
 
 
@@ -196,7 +197,7 @@ tui_source_exec_info_win_ptr (void)
 struct tui_gen_win_info *
 tui_disassem_exec_info_win_ptr (void)
 {
-  return &exec_info[1];
+  return &disasm_win;
 }
 
 
@@ -389,17 +390,6 @@ tui_initialize_static_data (void)
 }
 
 
-struct tui_gen_win_info *
-tui_alloc_generic_win_info (void)
-{
-  struct tui_gen_win_info *win = XNEW (struct tui_gen_win_info);
-
-  tui_init_generic_part (win);
-
-  return win;
-}
-
-
 void
 tui_init_generic_part (struct tui_gen_win_info *win)
 {
@@ -435,9 +425,7 @@ init_content_element (struct tui_win_element *element,
       element->which_element.source.has_break = FALSE;
       break;
     case DATA_WIN:
-      element->which_element.data_window = XNEW (struct tui_gen_win_info);
-      tui_init_generic_part (element->which_element.data_window);
-      element->which_element.data_window->type = DATA_ITEM_WIN;
+      element->which_element.data_window = new struct tui_gen_win_info (DATA_ITEM_WIN);
       element->which_element.data_window->content =
 	tui_alloc_content (1, DATA_ITEM_WIN);
       element->which_element.data_window->content_size = 1;
@@ -469,9 +457,8 @@ init_content_element (struct tui_win_element *element,
 }
 
 tui_win_info::tui_win_info (enum tui_win_type type)
+  : generic (type)
 {
-  generic.type = type;
-  tui_init_generic_part (&generic);
 }
 
 tui_source_window_base::tui_source_window_base (enum tui_win_type type)
@@ -711,7 +698,7 @@ free_content_elements (tui_win_content content,
 		      xfree (element->which_element.source.line);
 		      break;
 		    case DATA_WIN:
-		      xfree (element->which_element.data_window);
+		      delete element->which_element.data_window;
 		      xfree (element);
 		      break;
 		    case DATA_ITEM_WIN:
diff --git a/gdb/tui/tui-data.h b/gdb/tui/tui-data.h
index f915d209782..1fc9e32c5c5 100644
--- a/gdb/tui/tui-data.h
+++ b/gdb/tui/tui-data.h
@@ -39,18 +39,39 @@ typedef struct tui_win_element **tui_win_content;
 /* Generic window information.  */
 struct tui_gen_win_info
 {
-  WINDOW *handle;	    /* Window handle.  */
-  enum tui_win_type type;   /* Type of window.  */
-  int width;		    /* Window width.  */
-  int height;		    /* Window height.  */
-  struct tui_point origin;  /* Origin of window.  */
-  tui_win_content content;  /* Content of window.  */
-  int content_size;	    /* Size of content (# of elements).  */
-  int content_in_use;	    /* Can it be used, or is it already used?  */
-  int viewport_height;	    /* Viewport height.  */
-  int last_visible_line;    /* Index of last visible line.  */
-  bool is_visible;	    /* Whether the window is visible or not.  */
-  char *title;              /* Window title to display.  */
+  explicit tui_gen_win_info (enum tui_win_type t)
+    : type (t)
+  {
+  }
+
+  ~tui_gen_win_info ()
+  {
+  }
+
+  /* Window handle.  */
+  WINDOW *handle = nullptr;
+  /* Type of window.  */
+  enum tui_win_type type;
+  /* Window width.  */
+  int width = 0;
+  /* Window height.  */
+  int height = 0;
+  /* Origin of window.  */
+  struct tui_point origin = {0, 0};
+  /* Content of window.  */
+  tui_win_content content = nullptr;
+  /* Size of content (# of elements).  */
+  int content_size = 0;
+  /* Can it be used, or is it already used?  */
+  int content_in_use = FALSE;
+  /* Viewport height.  */
+  int viewport_height = 0;
+  /* Index of last visible line.  */
+  int last_visible_line = 0;
+  /* Whether the window is visible or not.  */
+  bool is_visible = false;
+  /* Window title to display.  */
+  char *title = nullptr;
 };
 
 /* Constant definitions.  */
@@ -465,7 +486,6 @@ extern struct tui_win_info *tui_win_list[MAX_MAJOR_WINDOWS];
 
 /* Data Manipulation Functions.  */
 extern void tui_initialize_static_data (void);
-extern struct tui_gen_win_info *tui_alloc_generic_win_info (void);
 extern struct tui_win_info *tui_alloc_win_info (enum tui_win_type);
 extern void tui_init_generic_part (struct tui_gen_win_info *);
 extern tui_win_content tui_alloc_content (int, enum tui_win_type);
diff --git a/gdb/tui/tui-layout.c b/gdb/tui/tui-layout.c
index d060c5c7807..556bef833a3 100644
--- a/gdb/tui/tui-layout.c
+++ b/gdb/tui/tui-layout.c
@@ -822,7 +822,7 @@ init_and_make_win (void *opaque_win_info,
   if (opaque_win_info == NULL)
     {
       if (tui_win_is_auxillary (win_type))
-	opaque_win_info = (void *) tui_alloc_generic_win_info ();
+	opaque_win_info = (void *) new tui_gen_win_info (win_type);
       else
 	opaque_win_info = (void *) tui_alloc_win_info (win_type);
     }